/*
//============================================================================
// Name        : simpleCJsonParser.c
// Author      : 
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C, Ansi-style
//============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "simpleCJson.h"
#include "cJSON/cJSON.h"

void parserJson(cJSON *jsondata) {

	printf("\n Let's read key and value from JSON string in c by using cJSON \n");

	const cJSON *_data = NULL;
	const cJSON *_dataObj = NULL;

	/*Converting cjson json to string*/
	char *_jsondata = cJSON_Print(jsondata);

	/* Parse cJSON */
	cJSON *jsonData = cJSON_Parse(_jsondata);

	/*Get string from JSON object*/
	_data = cJSON_GetObjectItemCaseSensitive(jsonData, "name");
	if (cJSON_IsString(_data) && (_data->valuestring != NULL))
	{
		printf("	Key : 'name' | Value : \"%s\"\n", _data->valuestring);
	}

	/*Get string from JSON object*/
	_data = cJSON_GetObjectItemCaseSensitive(jsonData, "size");
	if (cJSON_IsString(_data) && (_data->valuestring != NULL))
	{
		printf("	Key : 'size' | Value : \"%s\"\n", _data->valuestring);
	}

	/*Get array from JSON object*/
	_data = cJSON_GetObjectItemCaseSensitive(jsonData, "section");
	if (cJSON_IsArray(_data))
	{
		printf("	Key : 'section'\n");
		int i = 0;
		for (i = 0 ; i < cJSON_GetArraySize(_data) ; i++)
		{
			printf("		Index : '%d' | Value : %d \n",cJSON_GetArrayItem(_data, i)->valueint);
		}
	}

	/*Get Object from JSON Array */
	_data = cJSON_GetObjectItemCaseSensitive(jsonData, "updateby");
	if (cJSON_IsArray(_data))
	{
		int i = 0;
		for (i = 0 ; i < cJSON_GetArraySize(_data) ; i++)
		{
			_dataObj = cJSON_GetArrayItem(_data, i);
			printf("	Key : 'updateby' | Value : %s \n",cJSON_Print(_dataObj));
		}
	}

	_data = cJSON_GetObjectItemCaseSensitive(jsonData, "Metadata");
	if (cJSON_IsObject(_data)) {
		printf("	Key : 'Metadata' | Value : %s \n",cJSON_Print(_data));
	}


	cJSON_Delete(jsonData);
}
