/*
//============================================================================
// Name        : simpleCJsonWriter.c
// Author      : 
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C, Ansi-style
//============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "simpleCJson.h"
#include "cJSON/cJSON.h"

cJSON* writeJson(void) {

	printf("Let's write/create JSON in c by using cJSON \n");

	/* declare JSON Object. */
	cJSON *jsonData = cJSON_CreateObject();
	cJSON *jsonDataObj_one = cJSON_CreateObject();
	cJSON *jsonDataObj_two = cJSON_CreateObject();
	cJSON *jsonDataObj_metadata = cJSON_CreateObject();

	/* declare JSON Arrays. */
	cJSON *jsonDataArray = cJSON_CreateArray();

	/* Creating a JSON Array */
	int intArray[4] = { 1, 2, 3, 4 };

	/* array of strings */
	const char *role_one[3] =
	{
			"add",
			"update",
			"delete"
	};


	const char *role_two[2] =
	{
			"add",
			"delete"
	};


	cJSON_AddItemToObject(jsonData, "name", cJSON_CreateString("File.mp3"));
	cJSON_AddItemToObject(jsonData, "size", cJSON_CreateString("25Mb"));
	cJSON_AddItemToObject(jsonData, "section", cJSON_CreateIntArray(intArray, 4));


	cJSON_AddItemToObject(jsonDataArray, "updateby", jsonDataObj_one);
	cJSON_AddStringToObject(jsonDataObj_one, "name", "user one");
	cJSON_AddStringToObject(jsonDataObj_one, "date", "10:00 21 May");

	/*Creating a JSON Array*/
	cJSON_AddItemToObject(jsonDataObj_one, "userrole", cJSON_CreateStringArray(role_one, 3));

	cJSON_AddItemToObject(jsonDataArray, "updateby", jsonDataObj_two);
	cJSON_AddStringToObject(jsonDataObj_two, "name", "user two");
	cJSON_AddStringToObject(jsonDataObj_two, "date", "10:00 21 May");


	cJSON_AddItemToObject(jsonDataObj_two, "userrole", cJSON_CreateStringArray(role_two, 2));

	/*Add Json Object array in Json*/
	cJSON_AddItemToObject(jsonData, "updateby", jsonDataArray);

	cJSON_AddItemToObject(jsonData, "Metadata", jsonDataObj_metadata);
	cJSON_AddStringToObject(jsonDataObj_metadata, "create", "21 MAy");
	cJSON_AddStringToObject(jsonDataObj_metadata, "audio", "acc");
	cJSON_AddStringToObject(jsonDataObj_metadata, "video", "H264");

	printf("Output JSON : \n %s \n", cJSON_Print(jsonData));

	return jsonData;
}
























